function P = Psat(T)
% Saturation pressure of CO2 at a given temperature T K
% Equation from Span, R. and Wagner, W. 1996
a = [-7.0602087;
      1.9391218;
     -1.6463597;
     -3.2995634];
t = [1;
     1.5;
     2;
     4];
Tc = 304.1282;
Pc = 7.3773e6;

P = Pc*exp(Tc/T*(a'*(1-T/Tc).^(t)));
